#ifndef MRBGEMS_MACHINE_GPIO_GPIO_H
#define MRBGEMS_MACHINE_GPIO_GPIO_H

#include <stdint.h>

typedef enum {
    MACHINE_GPIO_LOW,
    MACHINE_GPIO_HIGH,
    MACHINE_GPIO_END,
} machine_gpio_value_t;

typedef enum {
    MACHINE_GPIO_MODE_DISABLED,
    MACHINE_GPIO_MODE_INPUT,
    MACHINE_GPIO_MODE_OUTPUT_PUSHPULL,
    MACHINE_GPIO_MODE_OUTPUT_OPENDRAIN,
    MACHINE_GPIO_MODE_END,
} machine_gpio_mode_t;

typedef enum {
    MACHINE_GPIO_PULL_NONE,
    MACHINE_GPIO_PULL_UP,
    MACHINE_GPIO_PULL_DOWN,
    MACHINE_GPIO_PULL_END
} machine_gpio_pull_t;

typedef struct {
    machine_gpio_value_t initial_value;
    machine_gpio_mode_t  mode;
    machine_gpio_pull_t  pull;
} machine_gpio_config_t;

int mrb_machine_gpio_impl_config(uint32_t pin, machine_gpio_config_t *cfg);
int mrb_machine_gpio_impl_read(uint32_t pin);
int mrb_machine_gpio_impl_write(uint32_t pin, machine_gpio_value_t value);
int mrb_machine_gpio_impl_toggle(uint32_t pin);

#endif  // MRBGEMS_MACHINE_GPIO_GPIO_H
